#include <xc.h>
#include "LedF.h"
#include <stdlib.h>
#include <stdio.h>

void LedOn(void)
// spegne tutti i led IR
{
	LATA = LATA | 00011000;
	LATC = LATC | 00000101;
	LATD = LATD | 11111111;
	LATE = LATE | 00000111;
}

void LedOff(void)
// spegne tutti i led IR
{
	LATA = LATA & 11100111;
	LATC = LATC & 11111010;
	LATD = LATD & 00000000;
	LATE = LATE & 11111000;
}
unsigned char LedSelect(unsigned char LedNum)
// imposta le variabili relative al led da gestire
{
/* maschere per il set (OR) o il clear (AND) del singolo bit
   PORTx & IRxYoff -> clear del bit -> led spento
   PORTx | IRxYon  -> set   del bit -> led acceso
*/
switch (LedNum)
      {   
         case 0:// A4 IR OUT 0
         		Port  = & LATA;
				MaskOff= 0b11101111;
				MaskOn = 0b00010000;	
         		break;           
        case 1:// A5 IR OUT 1
         		Port  = & LATA;
				MaskOff= 0b11011111;
				MaskOn = 0b00100000;	
         		break; 
         case 2:// C0 IR OUT 2
         		Port  = & LATC;
				MaskOff= 0b11111110;
				MaskOn = 0b00000001;	
         		break;
         case 3:// C2 IR OUT 3
         		Port  = & LATC;
				MaskOff= 0b11111101;
				MaskOn = 0b00000010;	
         		break;
         case 4:// D0 IR OUT 4
         		Port  = & LATD;
				MaskOff= 0b11111110;
				MaskOn = 0b00000001;	
         		break;
         case 5:// D1 IR OUT 5
         		Port  = & LATD;
				MaskOff= 0b11111101;
				MaskOn = 0b00000010;	
         		break;
         case 6:// D2 IR OUT 6
           		Port  = & LATD;
				MaskOff= 0b11111011;
				MaskOn = 0b00000100;	
         		break; 
         case 7:// D3 IR OUT 7
         		Port  = & LATD;
				MaskOff= 0b11110111;
				MaskOn = 0b00001000;	
         		break;
         case 8:// D4 IR OUT 8
         		Port  = & LATD;
				MaskOff= 0b11101111;
				MaskOn = 0b00010000;	
         		break;
         case 9:// D5 IR OUT 9
         		Port  = & LATD;
				MaskOff= 0b11011111;
				MaskOn = 0b00100000;	
         		break;
         case 10:// D6 IR OUT 10
         		Port  = & LATD;
				MaskOff= 0b10111111;
				MaskOn = 0b01000000;	
         		break;
         case 11:// D7 IR OUT 11
         		Port  = & LATD;
				MaskOff= 0b01111111;
				MaskOn = 0b10000000;	
         		break;
         case 12:// E0 IR OUT 12
         		Port  = & LATE;
				MaskOff= 0b111111110;
				MaskOn = 0b000000001;	
         		break;
         case 13:// E1 IR OUT 13
         		Port  = & LATE;
				MaskOff= 0b111111101;
				MaskOn = 0b000000010;	
         		break;
         case 14:// E2 IR OUT 14
         		Port  = & LATE;
				MaskOff= 0b111111011;
				MaskOn = 0b000000100;	
         		break;
         case 15:// A3 IR OUT 15
         		Port  = & LATA;
				MaskOff= 0b11110111;
				MaskOn = 0b00001000;	
         		break;
         case 'd':// A3 IR OUT 1 modalita' debug "d"
         		Port  = & LATA;
				MaskOff= 0b11110111;
				MaskOn = 0b00001000;	
         		break;
         case 'h':// help "h"
         		printf("\n\n\r================================================\n\r");
         		printf("h = help\n\r");
         		printf("d = debug, converte in ASCII\n\r");
         		printf("t = test\n\n\r");
         		printf("Stringa di comandi (RS232 19.200 N 8 1):\n\r");
				printf(" 0-canale (0 - 15)\n\r");
				printf(" 1-protocollo\n\r");
				printf("    6-RC6\n\r");
				printf("    7-RC6 SKY\n\r");
				printf(" 2-indirizzo\n\r");
				printf(" 3-dato\n\n\r");
				printf("Errori:\n\r");
				printf(" 0 = OK\n\r");
				printf(" 1 = errore RX USART\n\r");
				printf(" 2 = timeout RX USART\n\r");
				printf(" 3 = canale fuori range\n\r");
				printf(" 4 = protocollo fuori range\n\r");
				printf("\n\r================================================\n\r");
         		RCerr=('\n');	
         		break; 
         case 't':// test
         		printf("\n\n\r================================================\n\r");
         		RCerr=(0);	
         		break; 
         default:
                LedOff();
                return (1);	// canale fuori range		
         		break;
       }  
return (0);               
}

