#include "CodeDataSkyHD.h"
#include "LedF.h"
#include "Delays.h"
#include "wrc_definitions.h"

void SkyHD_RC(void)
{
    unsigned char val;
    unsigned long t1;
	const unsigned long *tmp_ptr;
	unsigned int idx;
    const unsigned int EndDelay = 100;//ritardo alla fine del pacchetto IR (ms)
    
    LED1=1;		// segnalazione	
	
	if (!RCerr)	// skip se timeout o RX error 
	{
        //LedOff(); 				// spegne tutti i led
		if (!LedSelect(RC_LED_NUM)) 	// seleziona il canale da gestire
		{
			if (RC_LED_NUM == 'd') // debug mode trasforma ASCII in numerico
			{
				RC_PROT -= 0x30;
				RC_DATA -= 0x30;
			}
            
            if(RC_DATA <= Sky_Max)
            {
                /* Inizio ciclo di trasmissione della cifra */
                tmp_ptr=(const unsigned long *)Sky_cifra_array[RC_DATA];
                /* */

                val=1;
                LedOff();
                for(idx=0; idx<SkyHD_array_len[RC_DATA]; idx++)
                {
                    /* Aspetto un tempo pari ai valori letti dall'array */
                    t1=*((const  unsigned long *)tmp_ptr+idx);		/* us */
                    
                    /* Verifico il valore del bit da inviare */
                    if ( val == 0) 
                    {
                        LED_OFF;
                        DelayusOFF(t1); 

                    } 
                    else 
                    {
                        LED_ON;
                        DelayusON(t1); 
                    }
                    val=val^1; // nella codifica manchester c' sempre una variazione 1-0 e viceversa

                }
                LedOff();

                Delayms(EndDelay);
            }
            else
            {// not valid digit
                Delayms(EndDelay);
                RCerr=7;
            }
        }
        else
        {// Not valid LED channel
            Delayms(EndDelay);
            RCerr=3;
        }
	}	
	
	if (RC_LED_NUM == 'd') // debug mode trasforma numerico in ASCII 
	{
		RCerr += 0x30;
	}
    TxResult(RCerr);
    
    LED1=0;		// segnalazione	
}

