
#include "Test.h"
#include "wrc_definitions.h"// contiene: definizioni, prototipi funzioni
#include "Delays.h"
#include "LedF.h"
#include "CodeDataRC5.h"
#include "CodeDataSkyHD.h"


#ifdef TestProtocol 
    void RCTestNumbers(void)
    {
        int i;
        for(i=0; i<12; i++)
        {
            LedOff();
            RC_DATA=i;
            LED1=1;		// segnalazione	
            if(RC_PROT==0)
            {
                RC5_RC();	// trasmette comando ricevuto
            }
            else if(RC_PROT==1)
            {
                SkyHD_RC();	// trasmette comando ricevuto
            }   

            LED1=0;
            Delayms(500);
        }
    }
#endif

#ifdef TestSignal
    void RCTestSignal(void)
    {
        unsigned char val;
        unsigned int idx;
        const unsigned int EndDelay = 100;//ritardo alla fine del pacchetto IR (ms)

        LED1=1;		// segnalazione	

        if (!LedSelect(RC_LED_NUM)) 	// seleziona il canale da gestire
        {
            val=1;
            LedOff();
            for(idx=0; idx<10000; idx++)
            {
                if ( val == 0) 
                {
                    LED_OFF;
                    DelayusOFF(700); 
                } 
                else 
                {
                    LED_ON;
                    DelayusON(300); 
                }
                val=val^1; // nella codifica manchester c' sempre una variazione 1-0 e viceversa
            }
            LedOff();

            Delayms(EndDelay);
        }
        else
        {// Not valid LED channel
            Delayms(EndDelay);
            RCerr=3;
        }
        
        LED1=0;		// segnalazione	
    } 
#endif

