 /* ////////////////////////////////////////////////////////////////////////////
** File:      wrc.c
*/                                  
#define  Ver "wrc ver 0.3\r       by Guiott"
/* Autore:    Guido Ottaviani-->g.ottaviani@mediaprogetti.it<--
** Descrizione:Gestione telecomando a infrarossi multiplo   
**              
//////////////////////////////////////////////////////////////////////////////*/
#include <xc.h>

// include standard
#include "wrc_definitions.h"// contiene: definizioni, prototipi funzioni
#include <stdlib.h>
#include <math.h>
#include <pwm.h>
#include <usart.h>
#include <stdio.h>
#include "wrc_settings.h"	// contiene: settings
#include "CodeDataRC5.h"
#include "CodeDataSkyHD.h"
#include "Delays.h"
#include "LedF.h"
#include "Test.h"

void main (void)	// ==========
{	
	INTCONbits.GIEH=0;	// disabilitati tutti gli interrupt high
	INTCONbits.GIEL=0;	// disabilitati tutti gli interrupt low	
	
	Settings(); // imposta porte e registri (settings.h)
	
	LedOff();	// spegne tutti i led IR
	RC_TEST_FLAG = 0;
     
    Delayms(100);
	
	while (1) // main loop
	{
		RCerr = 0;
		RX_FLAG = 0;
		RXpoint = 0;
		
		INTCONbits.GIEH=1;	// abilita interrupt High
		INTCONbits.GIEL=1;	// abilita interrupt Low
		
#ifdef TestProtocol 
		while(1)
        {   
            LedOff();	
            RC_LED_NUM=0;
            RC_PROT=0;
            RCTestNumbers(); //test
        }
#endif        

#ifdef TestSignal
        while(1)
        {   
            LedOff();	
            RC_LED_NUM=0;
            RC_PROT=1;
            RCTestSignal(); //test
        }
#endif
        
		while (!RX_FLAG && !RC_TEST_FLAG)	// idle in attesa di comandi	
		{
			LedOff();	
		}
		if (RC_TEST_FLAG)
		{
			//RCTestNumbers();// trasmette prova
		}
		else
		{
            if(RC_PROT==0)
            {
                RC5_RC();	// trasmette comando ricevuto
            }
            else if(RC_PROT==1)
            {
                SkyHD_RC();	// trasmette comando ricevuto
            }
            else
            {
                TxResult(4); // protocol out of range
            }
		}
	}
}

/* Funzioni *******************************************************************/

void TxResult(unsigned char Result)
{
    WriteUSART(Result+0x30);
    WriteUSART('\n');
}

// Low priority interrupt routine
/*IntServiceRoutine***************************************************/
void interrupt low_priority low_isr(void)
{  
	if (PIR1bits.RCIF) 
	{ 
		TMR0H = 0xFF - 0xE4;
		TMR0L = 0xFF - 0xE2;// carica il timer 1,5s
		INTCONbits.TMR0IF = 0;// reset flag di interrupt
		INTCONbits.TMR0IE=1;// interrupt TMR0 ON
		/*	
			legge
			RC_LED_NUM
			RC_PROT
			RC_DATA
		*/
		RCstring[RXpoint] = ReadUSART();
		if (USART_Status.FRAME_ERROR || USART_Status.OVERRUN_ERROR )
		{
			RCerr = 1;		//  errore RX USART
			RX_FLAG	= 1;	// terminata ricezione
			INTCONbits.GIEH=0;	// disabilita timer timeout
			return;	
		}
		RXpoint ++;
		if (RXpoint >= 4)
		{
			RX_FLAG	= 1;	// terminata ricezione
			INTCONbits.TMR0IE=0;// interrupt TMR0 OFF
		}
	}  	       
}   // Low Priority IntServiceRoutine
/*********************************************************************/


// High priority interrupt routine
void interrupt high_isr(void)
{      
 if (INTCONbits.TMR0IF)//l'interrupt e' stato generato dall'overflow del timer 0 ?
 {
	INTCONbits.TMR0IE=0;// interrupt TMR0 OFF
    INTCONbits.TMR0IF = 0;// reset flag di interrupt
    switch (RC_LED_NUM)
    {
	    case 'h':
	    	RCerr=0;
	    	break;
	    case 't':
	    	RCerr=0;
         	RC_TEST_FLAG = 1;	// test mode
	    	break;
	   	default:
		   RC_TEST_FLAG = 0;
		   RCerr = 2;		//  errore timeout RX
		   break;
	} 
    RX_FLAG	= 1;	//	terminata ricezione
 } 	
			
}  // High Priority IntServiceRoutine
/*********************************************************************/
/*INTERRUPT==================================================================*/

