/*
viene incluso in "wrc.c", contiene:
	definizioni
	prototipi funzioni
*/


// PIC18F4620 Configuration Bit Settings

// 'C' source line config statements

#include <xc.h>

//uncomment to use this function as a debugger test
//#define TestProtocol 1
//#define TestSignal 1



// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.

// CONFIG1H
#pragma config OSC = HSPLL      // Oscillator Selection bits (HS oscillator, PLL enabled (Clock Frequency = 4 x FOSC1))
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable bit (Fail-Safe Clock Monitor disabled)
#pragma config IESO = OFF       // Internal/External Oscillator Switchover bit (Oscillator Switchover mode disabled)

// CONFIG2L
#pragma config PWRT = OFF       // Power-up Timer Enable bit (PWRT disabled)
#pragma config BOREN = SBORDIS  // Brown-out Reset Enable bits (Brown-out Reset enabled in hardware only (SBOREN is disabled))
#pragma config BORV = 3         // Brown Out Reset Voltage bits (Minimum setting)

// CONFIG2H
#pragma config WDT = OFF        // Watchdog Timer Enable bit (WDT disabled (control is placed on the SWDTEN bit))
#pragma config WDTPS = 32768    // Watchdog Timer Postscale Select bits (1:32768)

// CONFIG3H
#pragma config CCP2MX = PORTC   // CCP2 MUX bit (CCP2 input/output is multiplexed with RC1)
#pragma config PBADEN = ON      // PORTB A/D Enable bit (PORTB<4:0> pins are configured as analog input channels on Reset)
#pragma config LPT1OSC = OFF    // Low-Power Timer1 Oscillator Enable bit (Timer1 configured for higher power operation)
#pragma config MCLRE = ON       // MCLR Pin Enable bit (MCLR pin enabled; RE3 input pin disabled)

// CONFIG4L
#pragma config STVREN = ON      // Stack Full/Underflow Reset Enable bit (Stack full/underflow will cause Reset)
#pragma config LVP = OFF         // Single-Supply ICSP Enable bit (Single-Supply ICSP enabled)
#pragma config XINST = OFF      // Extended Instruction Set Enable bit (Instruction set extension and Indexed Addressing mode disabled (Legacy mode))

// CONFIG5L
#pragma config CP0 = OFF        // Code Protection bit (Block 0 (000800-003FFFh) not code-protected)
#pragma config CP1 = OFF        // Code Protection bit (Block 1 (004000-007FFFh) not code-protected)
#pragma config CP2 = OFF        // Code Protection bit (Block 2 (008000-00BFFFh) not code-protected)
#pragma config CP3 = OFF        // Code Protection bit (Block 3 (00C000-00FFFFh) not code-protected)

// CONFIG5H
#pragma config CPB = OFF        // Boot Block Code Protection bit (Boot block (000000-0007FFh) not code-protected)
#pragma config CPD = OFF        // Data EEPROM Code Protection bit (Data EEPROM not code-protected)

// CONFIG6L
#pragma config WRT0 = OFF       // Write Protection bit (Block 0 (000800-003FFFh) not write-protected)
#pragma config WRT1 = OFF       // Write Protection bit (Block 1 (004000-007FFFh) not write-protected)
#pragma config WRT2 = OFF       // Write Protection bit (Block 2 (008000-00BFFFh) not write-protected)
#pragma config WRT3 = OFF       // Write Protection bit (Block 3 (00C000-00FFFFh) not write-protected)

// CONFIG6H
#pragma config WRTC = OFF       // Configuration Register Write Protection bit (Configuration registers (300000-3000FFh) not write-protected)
#pragma config WRTB = OFF       // Boot Block Write Protection bit (Boot Block (000000-0007FFh) not write-protected)
#pragma config WRTD = OFF       // Data EEPROM Write Protection bit (Data EEPROM not write-protected)

// CONFIG7L
#pragma config EBTR0 = OFF      // Table Read Protection bit (Block 0 (000800-003FFFh) not protected from table reads executed in other blocks)
#pragma config EBTR1 = OFF      // Table Read Protection bit (Block 1 (004000-007FFFh) not protected from table reads executed in other blocks)
#pragma config EBTR2 = OFF      // Table Read Protection bit (Block 2 (008000-00BFFFh) not protected from table reads executed in other blocks)
#pragma config EBTR3 = OFF      // Table Read Protection bit (Block 3 (00C000-00FFFFh) not protected from table reads executed in other blocks)

// CONFIG7H
#pragma config EBTRB = OFF      // Boot Block Table Read Protection bit (Boot Block (000000-0007FFh) not protected from table reads executed in other blocks)

////////////////////////////////////////////////////////////

/* Definizioni globali++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
#define _XTAL_FREQ 40000000

//----- Definizione porte
#define INT1IF INTCON3bits.INT1IF 		// interrupt flag
#define INT2IF INTCON3bits.INT2IF 		// interrupt flag 
#define INT3IF INTCONbits.INT0IF		// interrupt flag

										// A0
										// A1
										// A2
										// A3 IR OUT 1				O
										// A4 IR OUT 2				O
										// A5 IR OUT 3				O
										// A6 OSC1
										// A7 OSC2
										// B0
										// B1
										// B2
#define LED1 PORTBbits.RB3				// B3 LED 					O
#define IR_IN PORTBbits.RB4				// B4 Ricevitore IR			I
#define RTS PORTBbits.RB5				// B5 Request To Send		I
										// B6 PGC (ICD2)
										// B7 PGD (ICD2)
										// C0 IR OUT 4				O
#define PWM PORTCbits.RC1				// C1 PWM 36KHz portante IR	O
										// C2 IR OUT 5				O
										// C3 SCL
										// C4 SDA
#define CTS PORTCbits.RC5				// C5 Clear To Send			O
										// C6 TX
										// C7 RX
										// D0 IR OUT 6				O
										// D1 IR OUT 7				O
										// D2 IR OUT 8				O
										// D3 IR OUT 9				O 
										// D4 IR OUT 10				O
										// D5 IR OUT 11				O
										// D6 IR OUT 12				O
										// D7 IR OUT 13				O
										// E0 IR OUT 14				O
										// E1 IR OUT 15				O
										// E2 IR OUT 16				O
										// E3 MCLR 

struct Bits{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};

struct Bits VARbits1;
extern union USART USART_Status;

//----- Variabili
int i = 0; // contatore generico
int j = 0; // contatore generico
unsigned char a =0; // contatore generico

// 0 e 1 in codifica Manchester
#define MANCH_0 (LED_OFF, RC6Tick(1), LED_ON,RC6Tick(1))
#define MANCH_1 (LED_ON, RC6Tick(1), LED_OFF,RC6Tick(1))

unsigned char RCstring[5];	

#define RC_LED_NUM RCstring[0]
#define RC_PROT RCstring[1]
#define RC_ADDR RCstring[2]
#define RC_DATA RCstring[3]
#define RC_MODE RCstring[4]

#define RX_FLAG VARbits1.bit0
#define RC_TEST_FLAG VARbits1.bit1

unsigned char RXbuffer[64];	// buffer RX
unsigned char RXpoint;	// puntatore buffer RX seriale
	
/* Fine definizioni++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++/

/* Prototipi funzioni *********************************************************/

void InterruptHandlerHigh (void);

void InterruptHandlerLow (void);

void TxResult(unsigned char Result);

/* Fine prototipi funzioni ****************************************************/
